﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml;
using System.Collections.ObjectModel;
using Windows.UI.Xaml.Media.Animation;
using System.ComponentModel;
using System.Windows.Input;
using Windows.UI.Popups;
using Windows.UI.Xaml.Controls;

namespace Carousel_115562
{
    public class CarouselProperties:NotificationObject
    {
        public CarouselProperties()
        {
            Images = new ObservableCollection<Custom>();

            for (int iCount = 1; iCount <= 5; iCount++)
            {
                images.Add(new Custom() { Image = "Assets/" + iCount + ".jpg", Content = "Navigate to new page" });
            }
            
        }

        private ObservableCollection<Custom> images;

        public ObservableCollection<Custom> Images
        {
            get { return images; }
            set { images = value; }
        }
        
    }

    public class Custom
    {
        public string Content { get; set; }

        public string Image { get; set; }

        private Command navigateCommand;
        public Command NavigateCommand
        {
            get
            {
                if (navigateCommand == null)
                {
                    navigateCommand = new Command(_ => Navigate());
                }
                return navigateCommand;
            }
        }
        private void Navigate()
        {
            App.MainFrame.Navigate(typeof(Page1), this.Image);
        }
        public Custom()
        { }

        public Custom(string content, string image)
        {
            Content = content;
            Image = image;
        }
    }

    public class NotificationObject : INotifyPropertyChanged
    {
        public void RaisePropertyChanged(string propertyname)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyname));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class Command : ICommand
    {
        private readonly Action<object> _execute;

        public Command(Action<object> execute)
        {
            if (execute == null)
            {
                throw new ArgumentNullException("execute");
            }
            _execute = execute;
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _execute(parameter);
        }

        public void RaiseCanExecuteChanged()
        {
            var handler = CanExecuteChanged;

            if (handler != null)
            {
                handler(this, EventArgs.Empty);
            }
        }
    }

}
